/*global define, require, console, cordova, navigator */

define(['app'], function (app) {
  'use strict';

  angular.element(document.getElementsByTagName('html')[0]).ready(function(){
    var height = '';
    var htmlFont = '';
    if (window.innerWidth == 320) {
      htmlFont = 96;
      //height = (window.innerHeight-0) == 568 ? 500 : 380;
      height = (window.innerHeight-0) == 568 ? 500 : 300;
    } else if (window.innerWidth == 360) {
      htmlFont = 100;
      height = window.innerHeight;
    } else {
      htmlFont = window.innerWidth / 3.75 ;
      height = window.innerHeight;
    }
    document.documentElement.style.fontSize = htmlFont + 'px';
    document.body.style.fontSize = 100 *height/667 +'px';
    try {
      angular.bootstrap(document, ['starter']);
    } catch (e) {
      console.error(e.stack || e.message || e);
    }
  });


  // 待验证
  //angular.element(document).ready(function () {
  //  console.log("bootstrap ready");
  //
  //  var startApp = function () {
  //    console.log('start app');
  //    angular.bootstrap(document, [app.name]);
  //  }
  //
  //  var onDeviceReady = function () {
  //    console.log("on deviceready");
  //    angular.element().ready(function () {
  //      startApp();
  //    });
  //  }
  //
  //  if (typeof cordova === 'undefined') {
  //    startApp();
  //  } else {
  //    document.addEventListener("deviceready", onDeviceReady, false);
  //  }
  //});
});
