/**
 * Created by FMG on 16/10/9.
 */

define(['app'], function (app) {
  'use strict';
  function ctrl($scope,$ionicPopup,storage,$ionicLoading,$http,$state,$translate,$timeout) {
    $scope.$on('$ionicView.beforeEnter',function(){
      myObj.webViewDidFinishLoad();
    });
    var result = myObj.getMessage();
    var deviceToken = myObj.getDeviceToken();
    var userInfo = JSON.parse(result);
    var lang = "";
    if ("ch" == userInfo.lngType) {
      lang = "login-zh";
    } else {
      lang = "login-en";
    }
    $translate.use(lang);

    $scope.showPassword = function() {
      $scope.show_psd = !$scope.show_psd
    }

    function showPop(title){
      var showTitle = $translate.instant(title);
      myObj.showStatus(showTitle);
    }
    // 测试
    //myObj.changeServerUrlStatus('0');
    //storage.set('isTest',1);

    // 发布
    myObj.changeServerUrlStatus('1');
    storage.set('isTest',0);

    var clickNum = '';
    $scope.changeServerURL = function(){
      return;
      clickNum++;
      if(clickNum==5){
        myObj.changeServerUrlStatus('1');
        APIURL = formalUrl_https;
        showPop('正式服务器');
        storage.set('isTest',0);
      } else if(clickNum==10){
        myObj.changeServerUrlStatus('0');
        APIURL = testUrl_https;
        showPop('测试服务器');
        clickNum = 0;
        storage.set('isTest',1);
      }
    }

    $scope.data = {};
    // 先获取数据
    var accountJSON = storage.get('account');
    if (typeof(accountJSON)== "undefined") {
      $scope.accountArr = new Array();
    } else {
      $scope.accountArr = JSON.parse(accountJSON);
    }
    $scope.isAccountUndefined = $scope.accountArr.length == 0;
    // 初始化
    $scope.$on("$ionicView.beforeEnter", function(){
      var index = $scope.accountArr.length -1;
        $scope.user = {
          account:$scope.accountArr[index],
          name: '',
          password:''
        }
    });
    $scope.hideAccountList = function(){
      if($scope.show_tel) {
        $scope.show_tel = false;
        $scope.accountSelectImg = 'down';
      }
    }
    $scope.$watch('user.account', function(newVal,oldVal){
      $scope.newAccount = newVal;
    });
    $scope.accountSelectImg = 'down';
    $scope.$on("$ionicView.beforeLeave", function(){
      $scope.show_tel = false;
      $scope.accountSelectImg = 'down';
    })
    $scope.showAccount = function() {
      $scope.show_tel = !$scope.show_tel;
      $scope.accountSelectImg = $scope.show_tel ? 'up':'down';
    }

    function dealHeader(url){
      var headersJson=myObj.getHeadersWithApi('/ppstrongs/'+url);
      var headers=JSON.parse(headersJson);
      $scope.authHeader = {
        'Content-Type': 'application/x-www-form-urlencoded',
        'X-Ca-Key':  headers.X_Ca_Key,
        'X-Ca-Sign':  headers.X_Ca_Sign,
        'X-Ca-Timestamp':  headers.X_Ca_Timestamp,
        'X-Ca-Nonce':  headers.X_Ca_Nonce
      }
    }
    function testAccount(account){
      var regPhone = /(^0{0,1}1[3|4|5|6|7|8|9][0-9]{9}$)/;
      var regEmail = /^[_\.0-9a-zA-Z-]+@([0-9a-zA-Z][0-9a-zA-Z-]+\.){1,4}[a-zA-Z]{2,3}$/
      if(!regPhone.test(account) && !regEmail.test(account)) {
        showPop('ACCOUNT_ILLEGAL');
        return false;
      }
      return true;
    }
    $scope.findPsw = function(){
      $state.go('findpsw',{params:$scope.newAccount});
    }
    $scope.login = function() {
      if(!testAccount($scope.user.account)) return;
      var user_account = $scope.user.account,
          password = $scope.user.password;
      if (!user_account || user_account == '') {
        showPop('ACCOUNT_NULL');
        return;
      }
      if (!password || password == '') {
        showPop('PSW_NULL');
        return;
      }
      // DES 加密
      var desPsw = myObj.DESEncrypt(password);
      // native
      var param = {
        UserAccount:user_account,
        password:desPsw,
        equipmentNo:deviceToken,
        userToken:userInfo.userToken,
        phoneType:userInfo.phoneType,
        lngType:userInfo.lngType,
        sourceApp:SourceApp
      }
      dealHeader('login.action');
      myObj.showLoading();
      $http({
        method: 'post',
        url: APIURL + 'login.action',
        data:param,
        headers: $scope.authHeader,
        transformRequest: function (obj) {
          var str = [];
          for (var p in obj) {
            str.push(encodeURIComponent(p) + "=" + encodeURIComponent(obj[p]));
          }
          return str.join("&");
        }
      }).success(function (data, status, headers, config) {
        if(data){
          if (data.resultCode == "1001") {
            myObj.hideLoading();
            storage.set('soundFlag',data.soundFlag);
            $scope.saveAccount($scope.user.account);
            // 保存登录信息，并跳转到camera
            myObj.gotoDestCtrl(angular.toJson(data));
          } else {
            myObj.error(angular.toJson(data));
          }
        } else{
          myObj.networkError();
        }
      }).error(function (data, status) {
        myObj.networkError();
      })
    };

    $scope.saveAccount = function (account){
      if($scope.accountArr.indexOf(account) <= -1) {
        $scope.accountArr.push(account);
        var accountStr = JSON.stringify($scope.accountArr);
        storage.set('account',accountStr);
      } else {
        var index = $scope.accountArr.indexOf(account);
        if(index == $scope.accountArr.length -1) {
          return;
        }
        $scope.accountArr.splice(index,1);
        $scope.accountArr.push(account);
        var accountStr = JSON.stringify($scope.accountArr);
        storage.set('account',accountStr);
      }
    }
    $scope.deleAccount = function(account){
      for (var i=0;i<$scope.accountArr.length;i++) {
        if($scope.accountArr[i] == account)
          $scope.accountArr.splice(i,1);
        break;
      }
      if ($scope.accountArr.length >0) {
        var accountStr = JSON.stringify($scope.accountArr);
        storage.set('account',accountStr);
        var accountP = JSON.parse(storage.get('account'));
        $scope.accountArr = accountP;
      } else {
        storage.remove('account');
      }
      $scope.isAccountUndefined = $scope.accountArr.length == 0;
    }
    $scope.selectAccount = function(account) {
      $scope.user.account = account;
      $scope.show_tel = false;
      $scope.accountSelectImg = 'down';
    }
    $scope.showPassword = function(){
      $scope.show_psd = !$scope.show_psd;
    };
  }
  ctrl.$inject = ['$scope','$ionicPopup','storage','$ionicLoading','$http','$state','$translate','$timeout'];
  app.registerController('loginCtrl',ctrl);
});
