/**
 * Created by FMG on 2016/11/13.
 */
define(['app'], function(app){
  'use strict';
  function ctrl($scope, $http, $ionicLoading,$stateParams, $translate) {
    var result = myObj.getMessage();
    //var result = '{"devTypeID":"2","deviceID":"53","deviceName":"SN_056566070","deviceUUID":"2LKZNE8XZ88BGD24111A","lngType":"zh","phoneType":"i","userId":"121","userName":"FMG","userToken":"5b18e39f-664c-4daa-906a-fca74bc8f9f7-241"}';
    var user = JSON.parse(result);
    var lang = "";
    if (user.lngType != "undefined" &&"ch" == user.lngType) {
      lang = "cloud-zh";
    } else {
      lang = "cloud-en";
    }
    $translate.use(lang);

    $scope.userName = user.userName;

    var cloudInfo = JSON.parse($stateParams.params);
    $scope.needPay = cloudInfo.payMoney;
    $scope.orderNum = '';

    function dealHeader(url){
      var headersJson=myObj.getHeadersWithApi('/ppstrongs/'+url);
      var headers=JSON.parse(headersJson);
      $scope.authHeader = {
        'Content-Type': 'application/x-www-form-urlencoded',
        'X-Ca-Key':  headers.X_Ca_Key,
        'X-Ca-Sign':  headers.X_Ca_Sign,
        'X-Ca-Timestamp':  headers.X_Ca_Timestamp,
        'X-Ca-Nonce':  headers.X_Ca_Nonce
      }
    }

    $scope.payOrder = function(val){

      var param = {
        userID:user.userId,
        deviceID: user.deviceID,
        serverTime:cloudInfo.serverTime,
        payMoney: cloudInfo.payMoney,
        mealType: cloudInfo.mealType,
        storageTime: cloudInfo.storageTime,
        payType: val,
        callback: '11',
        userToken : user.userToken,
        phoneType: user.phoneType,
        lngType:user.lngType,
        sourceApp:SourceApp
      }
      dealHeader('createPayOrders.action');

      $http({
        method: 'post',
        url: APIURL + 'createPayOrders.action',
        data:param,
        headers: $scope.authHeader,
        transformRequest: function (obj) {
          var str = [];
          for (var p in obj) {
            str.push(encodeURIComponent(p) + "=" + encodeURIComponent(obj[p]));
          }
          return str.join("&");
        }
      }).success(function (data, status, headers, config) {
        console.log(data);
        if ("1001" == data.resultCode) {
          $scope.orderNum = data.orderNum;
          $scope.refresh = true;
          myObj.pay(data.payUrl);
        } else if (data.resultCode == "1023") {
          myObj.showRepeatLogin();
        } else {
          myObj.error(angular.toJson(data));
        }
      }).error(function (data, status) {
        myObj.networkError();
      })
    };

    //返回原生APP
    $scope.backApp = function () {
      if($scope.refresh) {myObj.refreshNative()};
      myObj.onBackClick();
    };
  }
  ctrl.$inject = ['$scope', '$http', '$ionicLoading','$stateParams', '$translate'];
  app.registerController('cloudPayCtrl',ctrl);
});
