/**
 * Created by PPStrong on 16/12/5.
 */
define(['app'], function(app){
  'use strict';
  function ctrl($http,$scope,$cordovaCamera,$translate,$ionicLoading,$ionicHistory){
    //var result = myObj.getMessage();
    //var user = JSON.parse(result);
    var lang = "" || "zh";
    //if (user.lngType != "undefined" && "en" == user.lngType  ) {
    //  lang = "personal-en";
    //} else {
      lang = "personal-zh";
    //}
    $translate.use(lang);

    function dealHeader(url) {
      var headersJson = myObj.getHeadersWithApi('/ppstrongs/' + url);
      var headers = JSON.parse(headersJson);
      $scope.authHeader = {
        'Content-Type': 'application/x-www-form-urlencoded',
        'X-Ca-Key': headers.X_Ca_Key,
        'X-Ca-Sign': headers.X_Ca_Sign,
        'X-Ca-Timestamp': headers.X_Ca_Timestamp,
        'X-Ca-Nonce': headers.X_Ca_Nonce
      }
    }
    $scope.uploadHeadImage = function(){
      myObj.showLoading();
      var param = {
        userID:user.userID,
        userToken:user.userToken,
        phoneType:user.phoneType,
        lngType:user.lngType,
        sourceApp:SourceApp
      }
      dealHeader('updateImgUrl.action');

      $http({
        method: 'post',
        url: APIURL + 'updateImgUrl.action',
        data:param,
        headers: $scope.authHeader,
        transformRequest: function (obj) {
          var str = [];
          for (var p in obj) {
            str.push(encodeURIComponent(p) + "=" + encodeURIComponent(obj[p]));
          }
          return str.join("&");
        }
      }).success(function (data, status, headers, config) {
        console.log(data);
        if (data.resultCode == "1001") {

          console.log('结果' + data.result);
        } else if (data.resultCode == "1023") {
          myObj.showRepeatLogin();
        } else {
          myObj.error(angular.toJson(data));
        }
        //$ionicLoading.hide();
        myObj.hideLoading();
      }).error(function (data, status) {
        //$ionicLoading.hide();
        myObj.hideLoading();
        console.log(status);
        myObj.networkError();
      })
    }
    $scope.showPop = function(title){
      $scope.showTitle =title;
      var a = $timeout(function(){
        $scope.showTitle = '';
      },1000);
      a.then(function(){
        $ionicHistory.goBack();
      })
    }
    $scope.headImageSrc = 'img/friend/share_back.png';
    document.addEventListener("deviceready", function () {

      $scope.takePhoto = function () {
      var options = {
        quality: 75,
        destinationType: Camera.DestinationType.DATA_URL,
        sourceType: Camera.PictureSourceType.CAMERA,
        allowEdit: true,
        encodingType: Camera.EncodingType.JPEG,
        targetWidth: 500,
        targetHeight: 500,
        popoverOptions: CameraPopoverOptions,
        saveToPhotoAlbum: false,
        correctOrientation: true
      };

        $cordovaCamera.getPicture(options).then(function (imageData) {
          //var image = document.getElementById('imageFile');
          //image.src = "data:image/jpeg;base64," + imageData;
          $scope.headImageSrc = "data:image/jpeg;base64," + imageData;
          $scope.headImageData = imageData;
        }, function (err) {
          // error
        });
      }

      //选择照片
      $scope.pickImage = function () {
        var options = {
          quality: 75,
          destinationType: Camera.DestinationType.DATA_URL,
          sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
          allowEdit: true,
          encodingType: Camera.EncodingType.JPEG,
          targetWidth: 500,
          targetHeight: 500,
          popoverOptions: CameraPopoverOptions,
          saveToPhotoAlbum: false
        };

        $cordovaCamera.getPicture(options).then(function (imageData) {
          $scope.headImageSrc = "data:image/jpeg;base64," + imageData;
          $scope.headImageData = imageData;
        }, function (error) {
        })
      }
    }, false);
  }
  ctrl.$inject = ['$http','$scope','$cordovaCamera','$translate','$ionicLoading','$ionicHistory'];
  app.registerController('personalHeadCtrl', ctrl);
})
