/**
 * Created by PPStrong on 16/11/11.
 */
define(['app'], function(app){
  'use strict';
  function ctrl($scope, $http, $ionicLoading, $state, $translate,storage,$timeout) {
    $scope.$on('$ionicView.beforeEnter',function(){
      $scope.getCloudInfo();
    });
    $scope.$on('$ionicView.enter',function(){
      myObj.webViewDidFinishLoad();
    });

    //返回原生APP
    $scope.backApp = function () {
      myObj.onBackClick();
    };
    var result = myObj.getMessage();
    // 未购买
    //var result = '{"devTypeID":"2","deviceID":"53","deviceName":"SN_056566070","deviceUUID":"2LKZNE8XZ88BGD24111A","lngType":"en","phoneType":"i","userId":"171","userName":"FMG","userToken":"aeb24c71-bbb2-4cd0-a188-39a9f1e4aee8-341"}';

    var user = JSON.parse(result);
    var lang = "";
    if (user.lngType != "undefined" && "ch" == user.lngType) {
      lang = "cloud-zh";
    } else {
      lang = "cloud-en";
    }
    $translate.use(lang);
    APIURL = storage.get('isTest') == 0 || typeof(storage.get('isTest')) == "undefined" ? formalUrl_https:testUrl_https;

    var cloudPrice = {
      sevenM:'',
      sevenY:'',
      thirtyM:'',
      thirtyY:''
    }
    $scope.deviceName = user.deviceName;

    // 下拉刷新
    $scope.refreshList = function () {
      $scope.getCloudInfo();
      $scope.$broadcast('scroll.refreshComplete');
    }

    $scope.sevenButton = true;
    $scope.yearButton = true;
    $scope.changeRecord = function(isCurrent){
      if(isCurrent)return;
      $scope.sevenButton = !$scope.sevenButton;
      updatePrice();
    }
    $scope.changeTime = function(isCurrent){
      $scope.yearButton = isCurrent;
        if(isCurrent){
          $scope.timeTitle = 1;
          $scope.timeType = 'YEAR';
          updatePrice();
        } else {
          $scope.timeTitle = num;
          $scope.timeType = num > 1? 'MONTHS':'MONTH';
          updatePrice();
      }
      check();
    }
    function updatePrice(){
      if($scope.sevenButton && $scope.yearButton){ // 7-年
        $scope.totalPrice = '￥'+cloudPrice.sevenY;
      } else if(!$scope.sevenButton && $scope.yearButton){ // 30-年
        $scope.totalPrice = '￥'+cloudPrice.thirtyY;
      } else if($scope.sevenButton && !$scope.yearButton){ // 7-月
        $scope.totalPrice = '￥'+num*cloudPrice.sevenM;
        $scope.monthPrice = cloudPrice.sevenM;
      } else if(!$scope.sevenButton && !$scope.yearButton){ // 30-月
        $scope.totalPrice = '￥'+num*cloudPrice.thirtyM;
        $scope.monthPrice = cloudPrice.thirtyM;
      }
    }
    var num = 1;
    $scope.timeTitle = '1';
    $scope.timeType = 'YEAR';
    $scope.disableMinus = true;
    $scope.minusImg = '_disa';
    $scope.addImg = '_disa';
    $scope.disableAdd = true;
    $scope.addMonth = function(){
      num++;
      if(num>11){
        num = 11;
      }
      check();
    };
    $scope.minusMonth = function(){
      num--;
      if(num<1){
        num = 1;
      }
      check();
    };
    function check(){
      if($scope.yearButton){
        $scope.disableAdd = true;
        $scope.disableMinus = true;
        $scope.minusImg = '_disa';
        $scope.addImg = '_disa';
        return;
      } else if(num == 1) {
        $scope.disableMinus = true;
        $scope.disableAdd = false;
      } else if(num ==11){
        $scope.disableMinus = false;
        $scope.disableAdd = true;
      } else {
        $scope.disableMinus = false;
        $scope.disableAdd = false;
      }
      $scope.minusImg = $scope.disableMinus ? '_disa':'';
      $scope.addImg = $scope.disableAdd ? '_disa':'';
      $scope.timeTitle = num;
      $scope.timeType = num > 1? 'MONTHS':'MONTH';
      $scope.totalPrice = '￥ '+$scope.monthPrice * num;
    }

    function dealHeader(url){
      var headersJson=myObj.getHeadersWithApi('/ppstrongs/'+url);
      var headers=JSON.parse(headersJson);
      $scope.authHeader = {
        'Content-Type': 'application/x-www-form-urlencoded',
        'X-Ca-Key':  headers.X_Ca_Key,
        'X-Ca-Sign':  headers.X_Ca_Sign,
        'X-Ca-Timestamp':  headers.X_Ca_Timestamp,
        'X-Ca-Nonce':  headers.X_Ca_Nonce
      }
    }
    var param = {
      userID: user.userId,
      deviceID: user.deviceID,
      userToken : user.userToken,
      phoneType:user.phoneType,
      lngType:user.lngType,
      sourceApp:SourceApp
    }

    $scope.getCloudInfo = function(){
      dealHeader('selectCloudInfos.action');
      $http({
        method: 'post',
        url: APIURL + 'selectCloudInfos.action',
        data:param,
        headers: $scope.authHeader,
        transformRequest: function (obj) {
          var str = [];
          for (var p in obj) {
            str.push(encodeURIComponent(p) + "=" + encodeURIComponent(obj[p]));
          }
          return str.join("&");
        }
      }).success(function (data, status, headers, config) {
        console.log(data);
        if (data.resultCode == "1001") {
          myObj.hideLoading();
          dealData(data);
        } else if (data.resultCode == "1023") {
          myObj.showRepeatLogin();
        } else {
          myObj.error(angular.toJson(data));
        }
      }).error(function (data, status) {
        console.log(status);
        myObj.networkError();
      })
    }
    $scope.cloudImg = 'pic';
    // 处理服务器数据
    function dealData(data){
      cloudPrice.sevenM = data.sevenM;
      cloudPrice.thirtyM = data.thirtyM;
      cloudPrice.sevenY = data.sevenY;
      cloudPrice.thirtyY = data.thirtyY;
      if(data.cloudStatus != -1){
        var endTime = new Date(data.dueDate);
        if (user.lngType != "undefined" &&"en" == user.lngType) {
          $scope.formDate = 'dd/MM/yyyy';
        } else {
          $scope.formDate = 'yyyy-MM-dd';
        }
        $scope.serveEndTime = endTime;
      }
      if(data.cloudStatus == -1){
        $scope.cloudStatusTitle = 'UNOPENED';//'云服务未开通';
      } else if (data.cloudStatus == 1){
        $scope.cloudStatusTitle = 'EXPIRED';//'云服务已过期';
      } else if(data.cloudStatus == 2) {
        $scope.cloudStatusTitle = 'UNEXPIRED';//'云服务已开通';
        $scope.isCloudOpen = true;
        $scope.cloudImg = 'run';
      }
      if(data.trialCloud == 0 && data.cloudStatus == -1){ // 既没有开通又没有试用
        $scope.showTry = true;
      } else {
        $scope.showTry = false;
      }
      $scope.totalPrice = '￥'+cloudPrice.sevenY;
    }
    //7天试用
    $scope.tryUse = function(){
      myObj.showLoading();
      dealHeader('cloudStorageTrials.action');

      $http({
        method: 'post',
        url: APIURL + 'cloudStorageTrials.action',
        data:param,
        headers: $scope.authHeader,
        transformRequest: function (obj) {
          var str = [];
          for (var p in obj) {
            str.push(encodeURIComponent(p) + "=" + encodeURIComponent(obj[p]));
          }
          return str.join("&");
        }
      }).success(function (data, status, headers, config) {

        if ("1001" == data.resultCode || 1) {
          var a = $timeout(function(){
            $scope.getCloudInfo();
          },3000);
          myObj.refreshNative();
        } else if (data.resultCode == "1023") {
          myObj.showRepeatLogin();
        } else {
          myObj.error(angular.toJson(data));
        }
      }).error(function (data, status) {
        myObj.networkError();
      })
    }
    $scope.createOrder = function (){
      var paramDict = {
        storageTime : $scope.sevenButton? '7':'30',
        mealType : $scope.yearButton? 'Y':'M',
        serverTime: num,
        payMoney:$scope.totalPrice.slice(1)
      };
      console.log(paramDict);
      var paramStr = JSON.stringify(paramDict);
      console.log(paramStr);

      $state.go('cloudPay',{params:paramStr});
    }
  }
  ctrl.$inject = ['$scope', '$http', '$ionicLoading', '$state', '$translate','storage','$timeout'];
  app.registerController('cloudInfoCtrl',ctrl);
});
