/**
 * Created by PPStrong on 16/10/9.
 */
// 本地化存储
define([],function () {
  "use strict";
  var factory = function () {
      var  storage = window.localStorage;
      var  json = window.JSON;

      return{
        set: set,
        get: get,
        clear: clear,
        remove: remove
      };
      function set(key, value) {
        storage.setItem(key, json.stringify(value));
      }
      function get(key) {
        var value = json.parse(storage.getItem(key));
        if(null != value) {
          return value;
        }
        return undefined;
      }
      function clear(){
        storage.clear();
      }
      function remove(key){
        storage.removeItem(key);
      }
    }

  factory.$inject = [];
  return factory;
})
